//
//  ViewController.m
//  Tutorial
//
//  Created by Randy Palermo on 1/11/16.
//  Copyright (c) 2016 IDTech Products. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

@synthesize lcdTextView;
@synthesize logTextView;
@synthesize connectedLabel;

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    [[IDT_VP3300 sharedController] setDelegate:self];

}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) deviceConnected{
    [connectedLabel setText:@"VP3300 CONNECTED"];
}
-(void) deviceDisconnected{
    [connectedLabel setText:@"VP3300 DISCONNECTED"];
}

-(void) appendMessageToResults:(NSString*) message{
    [self performSelectorOnMainThread:@selector(_appendMessageToResults:) withObject:message waitUntilDone:false];
    
}
-(void) _appendMessageToResults:(id)object{
    [logTextView setText:[NSString stringWithFormat:@"%@\n====================\n%@",(NSString*)object, self.logTextView.text]];
    
    // [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
    
}

- (void) swipeMSRData:(IDTMSRData*)cardData{
    NSLog(@"--MSR event Received, Type: %d, data: %@", cardData.event, cardData.encTrack1);
    switch (cardData.event) {
        case EVENT_MSR_CARD_DATA:
        {
            switch (cardData.captureEncodeType) {
                case CAPTURE_ENCODE_TYPE_ISOABA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"ISO/ABA"]];
                    break;
                case CAPTURE_ENCODE_TYPE_AAMVA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"AA/MVA"]];
                    break;
                    
                case CAPTURE_ENCODE_TYPE_Other:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"Other"]];
                    break;
                    
                case CAPTURE_ENCODE_TYPE_Raw:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"Raw"]];
                    break;
                    
                case CAPTURE_ENCODE_TYPE_JIS_I:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"CAPTURE_ENCODE_TYPE_JIS_I"]];
                    break;
                    
                case CAPTURE_ENCODE_TYPE_JIS_II:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"CAPTURE_ENCODE_TYPE_JIS_II"]];
                    break;
                    
                default:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encode Type: %@", @"UNKNOWN"]];
                    
                    break;
            }
            switch (cardData.captureEncryptType) {
                case CAPTURE_ENCRYPT_TYPE_AES:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encrypt Type: %@", @"AES"]];
                    break;
                case CAPTURE_ENCRYPT_TYPE_TDES:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encrypt Type: %@", @"TDES"]];
                    break;
                case CAPTURE_ENCRYPT_TYPE_NO_ENCRYPTION:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encrypt Type: %@", @"NONE"]];
                    break;
                    
                    
                default:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encrypt Type: %@", @"UNKNOWN"]];
                    
                    break;
            }
            
            [self appendMessageToResults:[NSString stringWithFormat:@"Full card data: %@", cardData.cardData]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Track 1: %@", cardData.track1]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Track 2: %@", cardData.track2]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Track 3: %@", cardData.track3]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Length Track 1: %i", cardData.track1Length]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Length Track 2: %i", cardData.track2Length]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Length Track 3: %i", cardData.track3Length]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 1: %@", [IDTUtility dataToHexString:cardData.encTrack1]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 2: %@", [IDTUtility dataToHexString:cardData.encTrack2]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 3: %@", [IDTUtility dataToHexString:cardData.encTrack3]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 1: %@", [IDTUtility dataToHexString:cardData.hashTrack1]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 2: %@", [IDTUtility dataToHexString:cardData.hashTrack2]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 3: %@", [IDTUtility dataToHexString:cardData.hashTrack3]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"KSN: %@", [IDTUtility dataToHexString:cardData.KSN]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"\nSessionID: %@",  [IDTUtility dataToHexString:cardData.sessionID]]];
			[self appendMessageToResults:[NSString stringWithFormat:@"\nReader Serial Number: %@",  cardData.RSN]];
			[self appendMessageToResults:[NSString stringWithFormat:@"\nRead Status: %2X",  cardData.readStatus]];
			if (cardData.unencryptedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Unencrytped Tags: %@", [IDTUtility printDictionary:cardData.unencryptedTags]]];
			if (cardData.encryptedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Encrypted Tags: %@", [IDTUtility printDictionary:cardData.encryptedTags]]];
			if (cardData.maskedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Masked Tags: %@", [IDTUtility printDictionary:cardData.maskedTags]]];
			
			NSLog(@"Track 1: %@", cardData.track1);
			NSLog(@"Track 2: %@", cardData.track2);
			NSLog(@"Track 3: %@", cardData.track3);
			NSLog(@"Encoded Track 1: %@", [IDTUtility dataToHexString:cardData.encTrack1]);
			NSLog(@"Encoded Track 2: %@", [IDTUtility dataToHexString:cardData.encTrack2]);
			NSLog(@"Encoded Track 3: %@", [IDTUtility dataToHexString:cardData.encTrack3]);
			NSLog(@"Hash Track 1: %@", [IDTUtility dataToHexString:cardData.hashTrack1]);
			NSLog(@"Hash Track 2: %@", [IDTUtility dataToHexString:cardData.hashTrack2]);
			NSLog(@"Hash Track 3: %@", [IDTUtility dataToHexString:cardData.hashTrack3]);
			NSLog(@"SessionID: %@", [IDTUtility dataToHexString:cardData.sessionID]);
			NSLog(@"nReader Serial Number: %@", cardData.RSN);
			NSLog(@"Read Status: %2X", cardData.readStatus);
			NSLog(@"KSN: %@", [IDTUtility dataToHexString:cardData.KSN]);
            
            return;
        }
            break;
            
        case EVENT_MSR_CANCEL_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Cancel Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_BACKSPACE_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Backspace Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_ENTER_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Enter Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_UNKNOWN:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR unknown event, data: %@", cardData.encTrack1]];
            return;
        }
            break;
        case EVENT_MSR_TIMEOUT:
        {
            [self appendMessageToResults:@"(Event) MSR TIMEOUT"];
            return;
        }
        default:
            break;
    }
}



- (void) emvTransactionData:(IDTEMVData*)emvData errorCode:(int)error{
    NSLog(@"EMV_RESULT_CODE_V2_response = %2X",error);
    
    [self appendMessageToResults:[NSString stringWithFormat:@"EMV_RESULT_CODE_V2_response = %2X",error]];
    if (emvData == nil) {
        [self appendMessageToResults:[NSString stringWithFormat:@"EMV TRANSACTION ERROR. Refer to EMV_RESULT_CODE_V2_response = 0x%2X",error]];
        return;
    }
    
    if (emvData.resultCodeV2 == EMV_RESULT_CODE_V2_GO_ONLINE) {
        [self appendMessageToResults:@"ONLINE REQUEST"];
    }
    if (emvData.resultCodeV2 == EMV_RESULT_CODE_V2_APPROVED || emvData.resultCodeV2 == EMV_RESULT_CODE_V2_APPROVED_OFFLINE ) {
        [self appendMessageToResults:@"APPROVED"];
    }
    if (emvData.resultCodeV2 == EMV_RESULT_CODE_V2_SWIPE_NON_ICC) {
        [self appendMessageToResults:@"MSR Data Captured"];
    }
    
    if (emvData.cardType == 0) {
        [self appendMessageToResults:@"CONTACT"];
    }
    if (emvData.cardType == 1) {
        [self appendMessageToResults:@"CONTACTLESS"];
    }
    
	if (emvData.unencryptedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Unencrytped Tags: \n%@", [IDTUtility printDictionary:emvData.unencryptedTags]]];
	if (emvData.encryptedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Encrypted Tags: \n%@", [IDTUtility printDictionary:emvData.encryptedTags]]];
	if (emvData.maskedTags != nil) [self appendMessageToResults:[NSString stringWithFormat:@"Masked Tags: \n%@", [IDTUtility printDictionary:emvData.maskedTags]]];
	if (emvData.hasAdvise) [self appendMessageToResults:@"Response Has Advise Request"];
	if (emvData.hasReversal) [self appendMessageToResults:@"Response Has Reversal Request"];
	if (emvData.hasAdvise) NSLog(@"Response Has Advise Request");
	if (emvData.hasReversal) NSLog(@"Response Has Reversal Request");
	if (emvData.cardData != nil) [self swipeMSRData:emvData.cardData];
}


- (void) lcdDisplay:(int)mode  lines:(NSArray*)lines{
    NSMutableString* str = [NSMutableString new];
    if (lines != nil) {
        for (NSString* s in lines) {
            [str appendString:s];
            [str appendString:@"\n"];
        }
    }
    
    switch (mode) {
        case 0x10:
            //clear screen
            lcdTextView.text = @"";
            break;
        case 0x03:
            lcdTextView.text = str;
            break;
        case 0x01:
        case 0x02:
        case 0x08:{
            [[IDT_VP3300 sharedController] emv_callbackResponseLCD:mode selection:(unsigned char)1];;
        }
            
            break;
        default:
            break;
    }
}

- (void) plugStatusChange:(BOOL)deviceInserted{
    if (deviceInserted) {
        [self appendMessageToResults: @"device Attached. Attempting connection"];
        [[IDT_VP3300 sharedController] device_connectToAudioReader];
        
    }
    else{
        [self appendMessageToResults: @"device removed."];
    }
}

-(IBAction) getFirmware:(id)sender{
    NSString *result;
    logTextView.text = @"";
    RETURN_CODE rt = [[IDT_VP3300 sharedController]  device_getFirmwareVersion:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get FM info:  %@", result]];
    }
}

- (void) bluetoothPickerAlert:(UIAlertView*)view{
	[view show];
}

-(IBAction) startBLE:(id)sender{
    [self appendMessageToResults: @"Turning on BLE scanning"];
   	NSString* SPS_SERVICE_3300 =  @"1820";
	 [[IDT_VP3300 sharedController] setDelegate:self];
	[[IDT_VP3300 sharedController] scanForBLEDevices:2.0 serviceUUIDs:@[[CBUUID UUIDWithString:SPS_SERVICE_3300]] options:nil];
}
-(IBAction) startTransaction:(id)sender{
    logTextView.text = @"";
    RETURN_CODE rt = [[IDT_VP3300 sharedController] device_startTransaction:1.00 amtOther:0 type:0 timeout:60 tags:nil forceOnline:false  fallback:true];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: @"Start Transaction Command Accepted. Please Swipe/Insert/Tap"];
    }
}
-(IBAction) completeEMV:(id)sender{
    logTextView.text = @"";
    RETURN_CODE rt = [[IDT_VP3300 sharedController]  emv_completeOnlineEMVTransaction:true hostResponseTags:[IDTUtility hexToData:@"8A023030"] ];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: @"Complete Transaction Command Accepted"];
    }
}
-(IBAction) cancelTransaction:(id)sender{
    logTextView.text = @"";
    RETURN_CODE rt = [[IDT_VP3300 sharedController] device_cancelTransaction];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"Cancel Transaction: OK."];
    }
}

@end
